%% EQ/Peaking EQ for oneplus
%% Alix Wan
%%2019/1/23
%               b0_PPC3 = b0;           % data format is 1.31
%               b1_PPC3 = b1 / 2;      % data format is 2.30, hence need divided by 2
%              b2_PPC3 = b2;
%               a1_PPC3 = -a1 / 2;     % -1 is software cfg
%               a2_PPC3 = -a2;


clc
clear all
close all
format long

%% Step 1:  Basic parameters
Fs=48000;
Fc=1000;
Gain = 10;
Q = 0.71;
BW=0;
Ripple=0;
Type=0;
%Parameter Calculation

%%Step 2:  Basic parameters: Get the b0, b1, b2, a0, a1, a2 parameters from the formula in the document Andy sent or in the Audio-EQ-cookbook
%%%%%%%%%%%     Type 1:  For EQ (Equalizer Q factor)   
                    g=10^(Gain/20);
                    t0=2*pi*Fc/Fs;
                    if g >= 1
                        beta=t0/(2*Q);
                    else
                        beta=t0/(2*g*Q);
                    end
                    a2=-0.5*(1-beta)/(1+beta);
                    a1=(0.5-a2)*cos(t0);
                    b0=(g-1)*(0.25+0.5*a2)+0.5;
                    b1=-a1;
                    b2=-(g-1)*(0.25+0.5*a2)-a2;
                    % SOS Form
                    b=2*[b0 b1 b2];
                    a=[1 -2*a1 -2*a2];
                    b0 = b(1);
                    b1 = b(2);
                    b2 = b(3);
                    a1 = -a(2);
                    a2 = -a(3);     
                      
%%%%%%%%%%%     Type 2:    Peaking EQ      
%                         A = sqrt(10^(Gain / 20));
%                         w0=2*pi*Fc/Fs;
%                         alpha=sin(w0)/(2*Q);

%                       a0  =    1 + alpha/A;
%                       b0 =   (1 + alpha*A) / a0;
%                       b1 =   (-2*cos(w0))  / a0;
%                       b2 =   (1 - alpha*A) / a0;
%                       a1 =   (2*cos(w0))   / a0;
%                       a2 =  -(1 - alpha/A) / a0;
     

[b0 b1 b2 a1 a2]    % please compare the value with that in PPC3 GUI
a0=1;



%% in order to obtain the register vaules: please use following code to achieve this
%Step 2: Normalize the b0, b1, b2, a0, a1, a2 to get the b0_a0, b1_a0, b2_a0, a0_a0, a1_a0, a2_a0, k.

        
        b0= b0 / 2^4;              %5.27 format  
        b1= b1 / 2^4;              %5.27 format
        b2= b2 / 2^4;              %5.27 format
       
        a0=a0;                      
        a1=a1 / 2^4;              %5.27 format
        a2=a2 / 2^4;              %5.27 format



%Step 3: Transfer the b0_a0, b1_a0, b2_a0, a1_a0, a2_a0 to 32bit 2's complement

 B0= dec2hex(mod(min(round(2^(32-1)*b0),2^(32-1)-1),2^32),8);
 B1= dec2hex(mod(min(round(2^(32-1)*b1),2^(32-1)-1),2^32),8);
 B2= dec2hex(mod(min(round(2^(32-1)*b2),2^(32-1)-1),2^32),8);
 A1= dec2hex(mod(min(round(2^(32-1)*a1),2^(32-1)-1),2^32),8);
 A2= dec2hex(mod(min(round(2^(32-1)*a2),2^(32-1)-1),2^32),8);
 
 
 out = [B0 ' ' B1 ' ' B2 ' ' A1 ' ' A2]

 

